/*
 * @(#)ConsPersonList.java  2.0  14 February 2003
 */

/**
 * <P>class for constructed list of Persons.</P>
 */

import java.util.*;

class ConsPersonList extends APersonList{

    Person      first;
    APersonList rest;
    
    /*------------------------------------------------------------
     Constructor
     -----------------------------------------------------------*/
     ConsPersonList(Person aFirst, APersonList aRest){
        this.first = aFirst;
        this.rest  = aRest;
     }
     
    /*------------------------------------------------------------
     Sort the list of Person-s
     -----------------------------------------------------------*/
     APersonList sort(Comparator cmp){
        
        return (this.rest.sort(cmp)).insert(this.first, cmp);
     }
     
    /*------------------------------------------------------------
     Insert a given Person into this sorted list of Person-s
     -----------------------------------------------------------*/
     APersonList insert(Person p, Comparator cmp){

        if (cmp.compare(this.first, p) < 0)
            return new ConsPersonList(this.first, 
                           this.rest.sort(cmp).insert(p, cmp));
        else
            return new ConsPersonList(p, this);
     }
 
    /*--------------------------------------------------------
     Method to print the member data.
     -------------------------------------------------------*/
    
    public String toString(){
        return  ("\nnew " + this.getClass().getName() + "("
                + first  + ", "
                + rest + ")");
    }
}

