/* PeopleTest.java 11 February 2003 */

import java.util.*;

public class PeopleTest extends JPFalt 
{
    public static void main(String[] args) { new PeopleTest(); }

    ///////////////////////////////////////////////////////////
    // Place your actual methods here.                       //
    ///////////////////////////////////////////////////////////

    /*----------------------------------------------------------
     Data to use in several tests
     ---------------------------------------------------------*/

        /* Construct three new Person objects */
        public Person minnie = new Person("Mouse", "Minnie", 1934);
        public Person mickey = new Person("Mouse", "Mickey", 1928);
        public Person donald = new Person("Buggs", "Donald", 1937);
        public Person daisy  = new Person("Ducks", "Daisy", 1934);

        /*-------------------------------------------------------
        Object in an anonymous class which implements Comparator
        to compare two Person objects by full name.
        -------------------------------------------------------*/
        public Comparator byFullName = new Comparator(){
                
            public int compare(Object p, Object q){
            
                if ( (!(p instanceof Person)) || 
                     (!(q instanceof Person)) ){
                     
                    throw new ClassCastException();
                }
                    
                else {
                    String thisName = 
                        new String(((Person)p).last +
                                   ((Person)p).first);
                        
                    String thatName = 
                        new String(((Person)q).last + 
                                   ((Person)q).first);
                    
                    return 
                        ((String) thisName).compareTo((String) thatName);
                }
                         
            }; // end definition of the compare method
        };  // end definition of the object byFullName.
                       
        
        /*-------------------------------------------------------
        Object in an anonymous class which implements Comparator
        to compare two Person objects by the first name.
        -------------------------------------------------------*/
        public Comparator byFirstName = new Comparator(){
                
            public int compare(Object p, Object q){
            
                if ( (!(p instanceof Person)) || 
                     (!(q instanceof Person)) ){
                     
                    throw new ClassCastException();
                }
                    
                else {
                    return 
                        (((Person)p).first).compareTo(((Person)q).first);
                }
                                 
            } // end definition of the compare method
        };  // end definition of the object byFirstName.               
        
    
    /*-------------------------------------------------------------------
     Test suite for the class list of person
    --------------------------------------------------------------------*/
    void PersonTest() {
                
        /* show the values of the four persons */
        println(minnie);
        println(mickey);
        println(donald);
        println(daisy);
                
    }

    /*-------------------------------------------------------------------- 
     Test suite for sorting persons by their full name.
    --------------------------------------------------------------------*/
    void FullNameTest() {
                
        /* define several test lists */
        EmptyPersonList empty = new EmptyPersonList();
        
        APersonList list1 = new ConsPersonList(minnie,
                                new ConsPersonList(donald,
                                    new ConsPersonList(daisy,
                                        new ConsPersonList(mickey, empty))));

        actual(list1.sort(byFullName));
    }

    /*-------------------------------------------------------------------- 
     Test suite for sorting persons by their first name.
    --------------------------------------------------------------------*/
    void FirstNameTest() {
                
        /* define several test lists */
        EmptyPersonList empty = new EmptyPersonList();
        
        APersonList list1 = new ConsPersonList(minnie,
                                new ConsPersonList(donald,
                                    new ConsPersonList(daisy,
                                        new ConsPersonList(mickey, empty))));

        actual(list1.sort(byFirstName));
    }

    /*-------------------------------------------------------------------- 
     Test suite for sorting persons by their date of birth.
    --------------------------------------------------------------------*/
    void DateOfBirthTest() {
                
        /* define several test lists */
        EmptyPersonList empty = new EmptyPersonList();
        
        APersonList list1 = new ConsPersonList(minnie,
                                new ConsPersonList(donald,
                                    new ConsPersonList(daisy,
                                        new ConsPersonList(mickey, empty))));

        /* define the new Comparator object as the method argument */
        actual(list1.sort(
            
            /* the argument for the sort method: */
            new Comparator(){
            
                /* actual method that implements the Comparator interface */    
                    public int compare(Object p, Object q){
                    
                        if ( (!(p instanceof Person)) || 
                             (!(q instanceof Person)) ){
                             
                            throw new ClassCastException();
                        }
                            
                        else {
                            return 
                                (((Person)p).dob)-(((Person)q).dob);
                        }
                                         
                } 
                /* end definition of the compare method */
            }
            /* end of the argument for the sort method */
                                   ));
     }                              
    /*--------------------------------------------------------------------- 
     End of test suite for sorting list of persons
    ---------------------------------------------------------------------*/    
}
